var request = null;
var selectedText;

window.addEventListener("load", askPowerToolsOnLoad, false);

function askPowerToolsOnLoad() 
{
  this.initialized = true;
  this.strings = document.getElementById("askpowertools-strings");
  registerEvents();
}

function clearDDMenuItems(menu)
{ //removes driving directions menu items
  for(n = menu.childNodes.length - 1; n >= 0; n--)
  {
    if((menu.childNodes[n].getAttribute("id") != "context-askpowertools-ddfromsetlocation") && (menu.childNodes[n].getAttribute("id") != "context-askpowertools-ddtosetlocation"))
      menu.removeChild(menu.childNodes[n]);
  }
    
  return menu.childNodes.length;
}

function createDDMenuItem(name, addr1, addr2) 
{ //creates driving directions menu items
	var label = "";
	var menuitemFrom = document.createElement("menuitem");
	var menuitemTo = document.createElement("menuitem");
	
	if(addr1 != "")
		label +=addr1 + ",";
	label += addr2;
	
	menuitemFrom.setAttribute("id", "from-" + name);
	menuitemFrom.setAttribute("label", label);
	menuitemFrom.addEventListener("command", drivingDirectionsSearchFrom, false);
	document.getElementById("context-askpowertools-ddfromitems").appendChild(menuitemFrom);
	
	menuitemTo.setAttribute("id", "to-" + name);
	menuitemTo.setAttribute("label", label);
	menuitemTo.addEventListener("command", drivingDirectionsSearchTo, false);	
	document.getElementById("context-askpowertools-ddtoitems").appendChild(menuitemTo);
}

function generateParentMenu(event) //this handles the rendering of the top-level menu item
{
  var contextMenuItem;
  var contextMenuItemText;
  
  selectedText = getTextSelection();
  
  if(selectedText=="") 
  {
  	document.getElementById("context-askpowertools-topseparator").hidden = true;
	  document.getElementById("context-askpowertools-menu").hidden = true;
	} 
	else
  { 
	  document.getElementById("context-askpowertools-topseparator").hidden = false;   
	  contextMenuItem = document.getElementById("context-askpowertools-menu");
	  contextMenuItemText = strings.getString("menuText").replace("$",selectedText);
	  contextMenuItem.setAttribute("label", contextMenuItemText);
	  contextMenuItem.hidden = false;
   }
   
   event.stopPropagation();		
}

function generateSubMenus(event) 
{
  document.getElementById("context-askpowertools-blog").hidden = false;
  document.getElementById("context-askpowertools-dictionary").hidden = false;
  document.getElementById("context-askpowertools-encyclopedia").hidden = false;
  document.getElementById("context-askpowertools-images").hidden = false;
  document.getElementById("context-askpowertools-map").hidden = false;
  document.getElementById("context-askpowertools-mapdd").hidden = false;
  document.getElementById("context-askpowertools-mystuff").hidden = false;
  document.getElementById("context-askpowertools-news").hidden = false;
  document.getElementById("context-askpowertools-search").hidden = false;
  document.getElementById("context-askpowertools-shopping").hidden = false;
  document.getElementById("context-askpowertools-thesaurus").hidden = false;
  document.getElementById("context-askpowertools-weather").hidden = false;
  
  event.stopPropagation();
}

function generateSubMenusMapDD(event)
{
  getData(strings.getString("ask.myStuffUrl"), onLocationsDataReceived);
  event.stopPropagation();
}

function suppressEvents(event) 
{ //prevents popup menu events from bubbling up, improving efficiency
  event.stopPropagation();
}

function getData(url, callbackFunction)
{
	try 
	{
	  request = new XMLHttpRequest();
	  request.open("GET", url, true);
	  request.onreadystatechange = callbackFunction;
	  request.send('');
	}
	catch (e)
	{
	  alert(strings.getString("errors.HttpRequest") + e);
	}
}

function onLocationsDataReceived()
{
  try
  {
    if(request.readyState == 4 && request.status == 200)
    { 
      var response = request.responseText;
      var xmlDoc = document.implementation.createDocument("", "", null);
      xmlDoc.loadXML(response);
      
      if(xmlDoc != null)
      {
        clearDDMenuItems(document.getElementById("context-askpowertools-ddfromitems"));
        clearDDMenuItems(document.getElementById("context-askpowertools-ddtoitems"));
        
        var locations = xmlDoc.getElementsByTagName("location");        
		    for (var i = 0; i<locations.length; i++) 
			   createDDMenuItem(locations[i].getAttribute("name"), locations[i].getAttribute('addr1'), locations[i].getAttribute('addr2'));
      }
    }
  }
  catch(e)
  {
    alert(strings.getString("errors.OnLocationsDataReceived") + e);
  }  
}

function registerEvents()
{
  document.getElementById("contentAreaContextMenu").addEventListener("popupshowing", generateParentMenu, false);
  document.getElementById("context-askpowertools-menu-items").addEventListener("popupshowing", generateSubMenus, false);
  
  document.getElementById("context-askpowertools-blog").addEventListener("command", blogSearch, false);
  document.getElementById("context-askpowertools-ddfromitems").addEventListener("popupshowing", suppressEvents, false);
  document.getElementById("context-askpowertools-ddfromsetlocation").addEventListener("command", gotoPrefsPage, false);
  document.getElementById("context-askpowertools-ddtoitems").addEventListener("popupshowing", suppressEvents, false);
  document.getElementById("context-askpowertools-ddtosetlocation").addEventListener("command", gotoPrefsPage, false);
  document.getElementById("context-askpowertools-dictionary").addEventListener("command", dictionarySearch, false);
  document.getElementById("context-askpowertools-encyclopedia").addEventListener("command", encyclopediaSearch, false);
  document.getElementById("context-askpowertools-images").addEventListener("command", imageSearch, false);
  document.getElementById("context-askpowertools-map").addEventListener("command", mapSearch, false);
  document.getElementById("context-askpowertools-mapdd").addEventListener("popupshowing", generateSubMenusMapDD, false);
  document.getElementById("context-askpowertools-mystuff").addEventListener("command", mystuffSearch, false);  
  document.getElementById("context-askpowertools-news").addEventListener("command", newsSearch, false);  
  document.getElementById("context-askpowertools-search").addEventListener("command", webSearch, false);
  document.getElementById("context-askpowertools-shopping").addEventListener("command", shoppingSearch, false);
  document.getElementById("context-askpowertools-thesaurus").addEventListener("command", thesaurusSearch, false);
  document.getElementById("context-askpowertools-weather").addEventListener("command", weatherSearch, false);
}